library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity transcod7segs IS PORT(
     e : in std_logic_vector(3 downto 0);
	  hl : in std_logic;
     s7segs : out std_logic_vector(6 downto 0));
END entity;

architecture behavior of transcod7segs is
signal onoff : std_logic_vector(6 downto 0);
begin

		with e select
-- 						 gfedcba
				onoff <= "0111111" when "0000", -- cas hexdec = 1  donc decodage 0 -> F
							"0000110" when "0001",	
							"1011011" when "0010", 
							"1001111" when "0011",	
							"1100110" when "0100",
							"1101101" when "0101",
							"1111101" when "0110",
							"0000111" when "0111",
							"1111111" when "1000",
							"1101111" when "1001",
							"1110111" when "1010",
							"1111100" when "1011",
							"0111001" when "1100",
							"1011110" when "1101",
							"1111001" when "1110",
							"1110001" when "1111",
							"1000000" when others;	-- - quand il y a erreur
							
	process(hl,onoff) begin
		if (hl='1') then
			s7segs <= onoff;
		else
			s7segs <= not onoff;
		end if;
	end process;

end behavior;